// file: $isip_ifc/class/stat/Histogram/hist_01.cc
// version: $Id: hist_01.cc 10393 2006-01-25 05:20:55Z srinivas $
//

// isip include files
//
#include "Histogram.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: boolean value indicating status
//
// this is the debug method
//
boolean Histogram::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // output the scale information
  //
  output.debugStr(name(), msg_a, L"scale_d", SCALE_MAP((ushort)scale_d));
  Console::put(output);
  
  // output the bin mode information
  //
  output.debugStr(name(), msg_a, L"mode_d", MODE_MAP((ushort)mode_d));
  Console::put(output);

  // output dimension, bins, min, max, number of bins and counts information
  //
  Console::increaseIndention();

  dim_d.debug(L"dim_d");
  counts_d.debug(L"counts_d");
  bins_d.debug(L"bins_d");
  min_d.debug(L"min_d");
  max_d.debug(L"max_d");
  num_bins_d.debug(L"num_bins_d");
  block_boundary_index_d.debug(L"block_boundary_index_d");
  
  Console::decreaseIndention();

  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
